Public Class frmRunExp

    ' Declarations:
    Dim stpRtStopwatch As Stopwatch
    Dim intRespTime, intRespFlag, intColor, intStimRT As Integer
    Dim intJudgResp(3), intJudgRespTime(3) As Integer
    Dim intJudgCount, intStimCount, intStimPointer As Integer
    Dim strResp, strJudgFileName As String
    Dim strOptionLabel(3, 9) As String ' holds captions for judg options
    Dim intOptionCount, intNumOptions(3) As Integer
    Dim strOptionText As String
    Dim objRespFile As New System.IO.StreamWriter(strRespFileName)


    Public Sub frmRunExp_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' initialize runtime variables and controls:
        intTrialCount = 0
        intBlockTrialCount = 0
        tmrInterTrialDur.Interval = intITI
        ' set StimDisplay font size (got this online):
        fntStimFont = lblStimWindow.Font
        lblStimWindow.Font = New Font(fntStimFont.Name, intFontSize, FontStyle.Regular)
        ' create RT Timer:
        stpRtStopwatch = New Stopwatch
        ' create output file:
        ' write header to rsp file:
        objRespFile.WriteLine("trl StimID respcode RT [Judg1 Time1 Judg2 Time2 Judg3 Time3] Color")

        ' Load captions for any judgments (each with 1-5 options):
        If intNumJudg > 0 Then
            For intJudgCount = 1 To intNumJudg
                strJudgFileName = strExpIDstem + "_" + CStr(intJudgCount) + ".jdg"
                Dim objJudgFile As New System.IO.StreamReader(strJudgFileName)
                intOptionCount = 0
                strOptionText = objJudgFile.ReadLine()
                Do Until strOptionText Is Nothing
                    intOptionCount = intOptionCount + 1
                    strOptionLabel(intJudgCount, intOptionCount) = strOptionText
                    strOptionText = objJudgFile.ReadLine()
                Loop
                ' save number of options for this judgment:
                intNumOptions(intJudgCount) = intOptionCount
                objJudgFile.Close()
                objJudgFile.Dispose()
            Next
        End If
    End Sub

    Private Sub tmrInterTrialDur_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrInterTrialDur.Tick
        tmrInterTrialDur.Enabled = False
        intStimRT = 0
        strResp = "" ' linked to keypress check
        intTrialCount = intTrialCount + 1
        intBlockTrialCount = intBlockTrialCount + 1
        intSeqCount = 1
        stpRtStopwatch.Reset()
        tmrPreSeqDur.Interval = intPreSeqIntvl(intSeqCount) ' fixed bug where this didn't get reset soon enough
        tmrPreSeqDur.Enabled = True
    End Sub

    Private Sub tmrPreSeqDur_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrPreSeqDur.Tick
        tmrPreSeqDur.Enabled = False
        ' set up timing params for this sequence:
        tmrFixateDur.Interval = intFixIntvl(intSeqCount)
        tmrPostFixDur.Interval = intPostFixIntvl(intSeqCount)
        tmrStimOnDur.Interval = intStimIntvl(intSeqCount)
        tmrInterStimDur.Interval = intISIntvl(intSeqCount)
        tmrPostSeqDur.Interval = intPostSeqIntvl(intSeqCount)
        ' initialize settings:
        intStimCount = 1
        If tmrFixateDur.Interval < 10 Then
            PostFix()
        Else : lblStimWindow.ForeColor = Color.Black
            lblStimWindow.Text = "    +++++    "   ' other fixation symbols can be put here
            tmrFixateDur.Enabled = True
        End If
    End Sub

    Private Sub tmrFixateDur_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrFixateDur.Tick
        tmrFixateDur.Enabled = False
        lblStimWindow.Text = "        "
        PostFix()
    End Sub

    Private Sub PostFix()
        ' called by end of preseq or end of fixation
        tmrPostFixDur.Enabled = False
        ShowNextStim()
    End Sub

    Private Sub tmrPostFixDur_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrPostFixDur.Tick
        tmrPostFixDur.Enabled = False
        ShowNextStim()
    End Sub

    Private Sub ShowNextStim()
        intStimPointer = intTrialOrder(intTrialCount, 1)
        intColor = intStimColor(intStimPointer, intSeqCount, intStimCount)
        If intColor = 0 Then
            intColor = intRandNum.Next(2, 6) ' this is study-specific; make it more generic and flexible 2/08
        End If
        Select Case intColor
            Case 1
                lblStimWindow.ForeColor = Color.Black
            Case 2
                lblStimWindow.ForeColor = Color.Red
            Case 3
                lblStimWindow.ForeColor = Color.Green
            Case 4
                lblStimWindow.ForeColor = Color.SaddleBrown
            Case 5
                lblStimWindow.ForeColor = Color.Blue
            Case 6
                lblStimWindow.ForeColor = Color.Purple
            Case 7
                lblStimWindow.ForeColor = Color.Orange
            Case 8
                lblStimWindow.ForeColor = Color.Yellow
            Case 9
                lblStimWindow.ForeColor = Color.White
        End Select
        ' get next stim in sequence:
        lblStimWindow.Text = strStimSeq(intStimPointer, intSeqCount, intStimCount)
        ' put focus on form itself, so keypress gets caught (no other impact?)
        Me.Focus()
        ' start RT stopwatch if this is constant-position RT trigger stim
        If intStimCount = intRtStim(intSeqCount) Then
            stpRtStopwatch.Start()
        End If
        ' start RT stopwatch if this is a @-triggered stim:
        If intStimCount = intStimRtStart(intStimPointer) And intSeqCount = intSeqRtStart(intStimPointer) Then
            stpRtStopwatch.Start()
        End If
        ' start fixed Dur stimulus interval if appropriate:
        If intSelfPaced(intSeqCount) = 0 Then
            tmrStimOnDur.Enabled = True
        End If
    End Sub

    Private Sub tmrStimOnDur_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrStimOnDur.Tick
        tmrStimOnDur.Enabled = False
        intRespTime = stpRtStopwatch.ElapsedMilliseconds
        AfterStim()
    End Sub

    Private Sub tmrPostSeqDur_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrPostSeqDur.Tick
        tmrPostSeqDur.Enabled = False
        ' end of last sequence?
        If intSeqCount = intNumSeq Then
            ' show judgs if called for:
            If intNumJudg > 0 Then
                intJudgCount = 1
                ShowJudg()
            Else : EndofTrial()
            End If
        Else : intSeqCount = intSeqCount + 1
            tmrPreSeqDur.Interval = intPreSeqIntvl(intSeqCount)
            tmrPreSeqDur.Enabled = True
        End If
    End Sub

    Private Sub ShowJudg()
        If intJudgCount > intNumJudg Then
            btnEnterJudg.Visible = False
            EndofTrial()
        Else : lstJudgOpts.Items.Clear()
            For intOptionCount = 1 To intNumOptions(intJudgCount)
                lstJudgOpts.Items.Add(strOptionLabel(intJudgCount, intOptionCount))
            Next ' Option listed, show listbox:
            lstJudgOpts.Visible = True
            ' reset & start Rsp timer and wait for judg button Click:
            btnEnterJudg.Visible = True
            stpRtStopwatch.Stop() ' in case subj hasn't responded
            stpRtStopwatch.Reset()
            stpRtStopwatch.Start()
        End If
    End Sub
    Private Sub AfterStim()
        ' called after StimDur or Self-paced RT:
        lblStimWindow.Text = "              "
        If intStimCount = intLastStim(intStimPointer, intSeqCount) Then
            tmrPostSeqDur.Enabled = True
        Else : intStimCount = intStimCount + 1
            tmrInterStimDur.Enabled = True
        End If
    End Sub

    Private Sub EndofTrial()
        ' write trial data to response file:
        Dim strJudg, strJudgTime As String
        objRespFile.Write(CStr(intTrialCount) + " " _
            + strIdentifiers(intStimPointer) + " " _
            + strResp + " " + CStr(intStimRT) + " ")
        If intcolor > -1 Then
            objRespFile.Write(CStr(intColor))
        End If
        For intJudgCount = 1 To intNumJudg
            strJudg = CStr(intJudgResp(intJudgCount))
            strJudgTime = CStr(intJudgRespTime(intJudgCount))
            objRespFile.Write(strJudg + " " + strJudgTime + " ")
        Next
        objRespFile.WriteLine()
        ' last trial? If so, clean up and be done:
        If intTrialCount = intNumTrials Then
            btnEndExp.Visible = True
        ElseIf intBlockTrialCount = intBlockSize Then
            btnNextBlock.Visible = True
            intBlockTrialCount = 0
        Else : tmrInterTrialDur.Enabled = True
        End If
    End Sub

    Private Sub tmrInterStimDur_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrInterStimDur.Tick
        tmrInterStimDur.Enabled = False
        ShowNextStim()
    End Sub

    Private Sub btnNextBlock_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNextBlock.Click
        btnNextBlock.Visible = False
        tmrInterTrialDur.Enabled = True ' start next block of trials
    End Sub

    Private Sub btnEndExp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEndExp.Click
        objRespFile.Close()
        objRespFile.Dispose()
        frmSetup.Close()
        Me.Close()
    End Sub

    Private Sub btnBeginExp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBeginExp.Click
        btnBeginExp.Visible = False
        lblStimWindow.Visible = True
        tmrInterTrialDur.Enabled = True
    End Sub

    Private Sub btnEnterJudg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnterJudg.Click
        If lstJudgOpts.SelectedIndex > -1 Then
            ' get option selected (add one, indexing is 0 - N)
            stpRtStopwatch.Stop()
            intJudgRespTime(intJudgCount) = stpRtStopwatch.ElapsedMilliseconds
            intJudgResp(intJudgCount) = lstJudgOpts.SelectedIndex + 1
            intJudgCount = intJudgCount + 1
            lstJudgOpts.Visible = False
            ShowJudg()
        Else : MessageBox.Show("select a response before continuing!")
        End If
    End Sub

    Private Sub frmRunExp_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        If intSelfPaced(intSeqCount) = 0 And (strResp <> "" Or stpRtStopwatch.IsRunning = False) Then
            Exit Sub ' ignore spurious responses
        Else : stpRtStopwatch.Stop()
            intStimRT = stpRtStopwatch.ElapsedMilliseconds
            ' save mouse Button (first digit = 1 Left, 2 Right):
            strResp = "B" + Mid(CStr(e.Button), 1, 1)
            If intSelfPaced(intSeqCount) = 1 Then
                tmrStimOnDur.Enabled = False ' end current stim
                AfterStim()
            End If
        End If
    End Sub

    Private Sub frmRunExp_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        ' ignore spurious responses or long keydown:
        If (intSelfPaced(intSeqCount) = 0 And (strResp <> "" Or stpRtStopwatch.IsRunning = False)) _
            Or intRespFlag = 1 Then
            Exit Sub
            ' If it's an RT interval, capture the keystroke and stop the clock:
        Else : stpRtStopwatch.Stop()
            intStimRT = stpRtStopwatch.ElapsedMilliseconds
            ' save RT resp char:
            strResp = e.KeyCode
            intRespFlag = 1
            ' raise flag to avoid spillover to next trial
            If intSelfPaced(intSeqCount) = 1 Then
                tmrStimOnDur.Enabled = False ' end current stim
                AfterStim()
            End If
        End If
    End Sub

    Private Sub frmRunExp_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp
        ' clear RespFlag when key up
        intRespFlag = 0
    End Sub

End Class